
// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventing.py

******************************************************************/

#ifndef W
#define W(str) L##str
#endif
#ifndef SL
#define SL(str) str
#endif
#ifndef ERROR_SUCCESS
#define ERROR_SUCCESS 0L
#endif
#ifndef ERROR_WRITE_FAULT
#define ERROR_WRITE_FAULT 29L
#endif

#include "clreventpipewriteevents.h"

#if !defined(EVENTPIPE_TRACE_CONTEXT_DEF)
#define EVENTPIPE_TRACE_CONTEXT_DEF
typedef struct _EVENTPIPE_TRACE_CONTEXT
{
    const wchar_t * Name;
    uint8_t Level;
    bool IsEnabled;
    uint64_t EnabledKeywordsBitmask;
} EVENTPIPE_TRACE_CONTEXT, *PEVENTPIPE_TRACE_CONTEXT;
#endif // EVENTPIPE_TRACE_CONTEXT_DEF

static inline bool EventEnabledGCStart_V2(void) {return EventPipeEventEnabledGCStart_V2();}

static inline uint32_t FireEtwGCStart_V2(
    const uint32_t  Count,
    const uint32_t  Depth,
    const uint32_t  Reason,
    const uint32_t  Type,
    const uint16_t  ClrInstanceID,
    const uint64_t  ClientSequenceNumber,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCStart_V2(Count,Depth,Reason,Type,ClrInstanceID,ClientSequenceNumber,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCEnd_V1(void) {return EventPipeEventEnabledGCEnd_V1();}

static inline uint32_t FireEtwGCEnd_V1(
    const uint32_t  Count,
    const uint32_t  Depth,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCEnd_V1(Count,Depth,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledBulkType(void) {return EventPipeEventEnabledBulkType();}

static inline uint32_t FireEtwBulkType(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventBulkType(Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkRootEdge(void) {return EventPipeEventEnabledGCBulkRootEdge();}

static inline uint32_t FireEtwGCBulkRootEdge(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkRootEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkRootConditionalWeakTableElementEdge(void) {return EventPipeEventEnabledGCBulkRootConditionalWeakTableElementEdge();}

static inline uint32_t FireEtwGCBulkRootConditionalWeakTableElementEdge(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkRootConditionalWeakTableElementEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkNode(void) {return EventPipeEventEnabledGCBulkNode();}

static inline uint32_t FireEtwGCBulkNode(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkNode(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkEdge(void) {return EventPipeEventEnabledGCBulkEdge();}

static inline uint32_t FireEtwGCBulkEdge(
    const uint32_t  Index,
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledGCBulkRootStaticVar(void) {return EventPipeEventEnabledGCBulkRootStaticVar();}

static inline uint32_t FireEtwGCBulkRootStaticVar(
    const uint32_t  Count,
    const uint64_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventGCBulkRootStaticVar(Count,AppDomainID,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadStart(void) {return EventPipeEventEnabledThreadPoolWorkerThreadStart();}

static inline uint32_t FireEtwThreadPoolWorkerThreadStart(
    const uint32_t  ActiveWorkerThreadCount,
    const uint32_t  RetiredWorkerThreadCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadStart(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadStop(void) {return EventPipeEventEnabledThreadPoolWorkerThreadStop();}

static inline uint32_t FireEtwThreadPoolWorkerThreadStop(
    const uint32_t  ActiveWorkerThreadCount,
    const uint32_t  RetiredWorkerThreadCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadStop(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadAdjustmentSample(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentSample();}

static inline uint32_t FireEtwThreadPoolWorkerThreadAdjustmentSample(
    const double  Throughput,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentSample(Throughput,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadAdjustmentAdjustment(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentAdjustment();}

static inline uint32_t FireEtwThreadPoolWorkerThreadAdjustmentAdjustment(
    const double  AverageThroughput,
    const uint32_t  NewWorkerThreadCount,
    const uint32_t  Reason,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentAdjustment(AverageThroughput,NewWorkerThreadCount,Reason,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadAdjustmentStats(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentStats();}

static inline uint32_t FireEtwThreadPoolWorkerThreadAdjustmentStats(
    const double  Duration,
    const double  Throughput,
    const double  ThreadWave,
    const double  ThroughputWave,
    const double  ThroughputErrorEstimate,
    const double  AverageThroughputErrorEstimate,
    const double  ThroughputRatio,
    const double  Confidence,
    const double  NewControlSetting,
    const uint16_t  NewThreadWaveMagnitude,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentStats(Duration,Throughput,ThreadWave,ThroughputWave,ThroughputErrorEstimate,AverageThroughputErrorEstimate,ThroughputRatio,Confidence,NewControlSetting,NewThreadWaveMagnitude,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkerThreadWait(void) {return EventPipeEventEnabledThreadPoolWorkerThreadWait();}

static inline uint32_t FireEtwThreadPoolWorkerThreadWait(
    const uint32_t  ActiveWorkerThreadCount,
    const uint32_t  RetiredWorkerThreadCount,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkerThreadWait(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolMinMaxThreads(void) {return EventPipeEventEnabledThreadPoolMinMaxThreads();}

static inline uint32_t FireEtwThreadPoolMinMaxThreads(
    const uint16_t  MinWorkerThreads,
    const uint16_t  MaxWorkerThreads,
    const uint16_t  MinIOCompletionThreads,
    const uint16_t  MaxIOCompletionThreads,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolMinMaxThreads(MinWorkerThreads,MaxWorkerThreads,MinIOCompletionThreads,MaxIOCompletionThreads,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolWorkingThreadCount(void) {return EventPipeEventEnabledThreadPoolWorkingThreadCount();}

static inline uint32_t FireEtwThreadPoolWorkingThreadCount(
    const uint32_t  Count,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolWorkingThreadCount(Count,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolIOEnqueue(void) {return EventPipeEventEnabledThreadPoolIOEnqueue();}

static inline uint32_t FireEtwThreadPoolIOEnqueue(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const bool  MultiDequeues,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolIOEnqueue(NativeOverlapped,Overlapped,MultiDequeues,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolIODequeue(void) {return EventPipeEventEnabledThreadPoolIODequeue();}

static inline uint32_t FireEtwThreadPoolIODequeue(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolIODequeue(NativeOverlapped,Overlapped,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadPoolIOPack(void) {return EventPipeEventEnabledThreadPoolIOPack();}

static inline uint32_t FireEtwThreadPoolIOPack(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadPoolIOPack(NativeOverlapped,Overlapped,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDetails(void) {return EventPipeEventEnabledMethodDetails();}

static inline uint32_t FireEtwMethodDetails(
    const uint64_t  MethodID,
    const uint64_t  TypeID,
    const uint32_t  MethodToken,
    const uint32_t  TypeParameterCount,
    const uint64_t  LoaderModuleID,
    const uint64_t* TypeParameters,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDetails(MethodID,TypeID,MethodToken,TypeParameterCount,LoaderModuleID,TypeParameters,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTypeLoadStart(void) {return EventPipeEventEnabledTypeLoadStart();}

static inline uint32_t FireEtwTypeLoadStart(
    const uint32_t  TypeLoadStartID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTypeLoadStart(TypeLoadStartID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledTypeLoadStop(void) {return EventPipeEventEnabledTypeLoadStop();}

static inline uint32_t FireEtwTypeLoadStop(
    const uint32_t  TypeLoadStartID,
    const uint16_t  ClrInstanceID,
    const uint16_t  LoadLevel,
    const uint64_t  TypeID,
    const ep_char8_t*  TypeName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventTypeLoadStop(TypeLoadStartID,ClrInstanceID,LoadLevel,TypeID,TypeName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionThrown_V1(void) {return EventPipeEventEnabledExceptionThrown_V1();}

static inline uint32_t FireEtwExceptionThrown_V1(
    const ep_char8_t*  ExceptionType,
    const ep_char8_t*  ExceptionMessage,
    const void*  ExceptionEIP,
    const uint32_t  ExceptionHRESULT,
    const uint16_t  ExceptionFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionThrown_V1(ExceptionType,ExceptionMessage,ExceptionEIP,ExceptionHRESULT,ExceptionFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionCatchStart(void) {return EventPipeEventEnabledExceptionCatchStart();}

static inline uint32_t FireEtwExceptionCatchStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const ep_char8_t*  MethodName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionCatchStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionCatchStop(void) {return EventPipeEventEnabledExceptionCatchStop();}

static inline uint32_t FireEtwExceptionCatchStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionCatchStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionFinallyStart(void) {return EventPipeEventEnabledExceptionFinallyStart();}

static inline uint32_t FireEtwExceptionFinallyStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const ep_char8_t*  MethodName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionFinallyStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionFinallyStop(void) {return EventPipeEventEnabledExceptionFinallyStop();}

static inline uint32_t FireEtwExceptionFinallyStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionFinallyStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionFilterStart(void) {return EventPipeEventEnabledExceptionFilterStart();}

static inline uint32_t FireEtwExceptionFilterStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const ep_char8_t*  MethodName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionFilterStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionFilterStop(void) {return EventPipeEventEnabledExceptionFilterStop();}

static inline uint32_t FireEtwExceptionFilterStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionFilterStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExceptionThrownStop(void) {return EventPipeEventEnabledExceptionThrownStop();}

static inline uint32_t FireEtwExceptionThrownStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExceptionThrownStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionStart_V1(void) {return EventPipeEventEnabledContentionStart_V1();}

static inline uint32_t FireEtwContentionStart_V1(
    const uint8_t  ContentionFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionStart_V1(ContentionFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionStart_V2(void) {return EventPipeEventEnabledContentionStart_V2();}

static inline uint32_t FireEtwContentionStart_V2(
    const uint8_t  ContentionFlags,
    const uint16_t  ClrInstanceID,
    const void*  LockID,
    const void*  AssociatedObjectID,
    const uint64_t  LockOwnerThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionStart_V2(ContentionFlags,ClrInstanceID,LockID,AssociatedObjectID,LockOwnerThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionStop(void) {return EventPipeEventEnabledContentionStop();}

static inline uint32_t FireEtwContentionStop(
    const uint8_t  ContentionFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionStop(ContentionFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionStop_V1(void) {return EventPipeEventEnabledContentionStop_V1();}

static inline uint32_t FireEtwContentionStop_V1(
    const uint8_t  ContentionFlags,
    const uint16_t  ClrInstanceID,
    const double  DurationNs,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionStop_V1(ContentionFlags,ClrInstanceID,DurationNs,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledContentionLockCreated(void) {return EventPipeEventEnabledContentionLockCreated();}

static inline uint32_t FireEtwContentionLockCreated(
    const void*  LockID,
    const void*  AssociatedObjectID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventContentionLockCreated(LockID,AssociatedObjectID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadCreated(void) {return EventPipeEventEnabledThreadCreated();}

static inline uint32_t FireEtwThreadCreated(
    const uint64_t  ManagedThreadID,
    const uint64_t  AppDomainID,
    const uint32_t  Flags,
    const uint32_t  ManagedThreadIndex,
    const uint32_t  OSThreadID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadCreated(ManagedThreadID,AppDomainID,Flags,ManagedThreadIndex,OSThreadID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledThreadTerminated(void) {return EventPipeEventEnabledThreadTerminated();}

static inline uint32_t FireEtwThreadTerminated(
    const uint64_t  ManagedThreadID,
    const uint64_t  AppDomainID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventThreadTerminated(ManagedThreadID,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodLoad_V1(void) {return EventPipeEventEnabledMethodLoad_V1();}

static inline uint32_t FireEtwMethodLoad_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodLoad_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodLoadVerbose_V1(void) {return EventPipeEventEnabledMethodLoadVerbose_V1();}

static inline uint32_t FireEtwMethodLoadVerbose_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodLoadVerbose_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJittingStarted_V1(void) {return EventPipeEventEnabledMethodJittingStarted_V1();}

static inline uint32_t FireEtwMethodJittingStarted_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint32_t  MethodILSize,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJittingStarted_V1(MethodID,ModuleID,MethodToken,MethodILSize,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodJitMemoryAllocatedForCode(void) {return EventPipeEventEnabledMethodJitMemoryAllocatedForCode();}

static inline uint32_t FireEtwMethodJitMemoryAllocatedForCode(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  JitHotCodeRequestSize,
    const uint64_t  JitRODataRequestSize,
    const uint64_t  AllocatedSizeForJitCode,
    const uint32_t  JitAllocFlag,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodJitMemoryAllocatedForCode(MethodID,ModuleID,JitHotCodeRequestSize,JitRODataRequestSize,AllocatedSizeForJitCode,JitAllocFlag,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodILToNativeMap(void) {return EventPipeEventEnabledMethodILToNativeMap();}

static inline uint32_t FireEtwMethodILToNativeMap(
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint8_t  MethodExtent,
    const uint16_t  CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodILToNativeMap(MethodID,ReJITID,MethodExtent,CountOfMapEntries,ILOffsets,NativeOffsets,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDomainModuleLoad_V1(void) {return EventPipeEventEnabledDomainModuleLoad_V1();}

static inline uint32_t FireEtwDomainModuleLoad_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDomainModuleLoad_V1(ModuleID,AssemblyID,AppDomainID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleLoad_V2(void) {return EventPipeEventEnabledModuleLoad_V2();}

static inline uint32_t FireEtwModuleLoad_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ManagedPdbSignature,
    const uint32_t  ManagedPdbAge,
    const ep_char8_t*  ManagedPdbBuildPath,
    const uint8_t* NativePdbSignature,
    const uint32_t  NativePdbAge,
    const ep_char8_t*  NativePdbBuildPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleLoad_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleUnload_V2(void) {return EventPipeEventEnabledModuleUnload_V2();}

static inline uint32_t FireEtwModuleUnload_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ManagedPdbSignature,
    const uint32_t  ManagedPdbAge,
    const ep_char8_t*  ManagedPdbBuildPath,
    const uint8_t* NativePdbSignature,
    const uint32_t  NativePdbAge,
    const ep_char8_t*  NativePdbBuildPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleUnload_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyLoad_V1(void) {return EventPipeEventEnabledAssemblyLoad_V1();}

static inline uint32_t FireEtwAssemblyLoad_V1(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint64_t  BindingID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyLoad_V1(AssemblyID,AppDomainID,BindingID,AssemblyFlags,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyUnload_V1(void) {return EventPipeEventEnabledAssemblyUnload_V1();}

static inline uint32_t FireEtwAssemblyUnload_V1(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint64_t  BindingID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyUnload_V1(AssemblyID,AppDomainID,BindingID,AssemblyFlags,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledWaitHandleWaitStart(void) {return EventPipeEventEnabledWaitHandleWaitStart();}

static inline uint32_t FireEtwWaitHandleWaitStart(
    const uint8_t  WaitSource,
    const void*  AssociatedObjectID,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventWaitHandleWaitStart(WaitSource,AssociatedObjectID,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledWaitHandleWaitStop(void) {return EventPipeEventEnabledWaitHandleWaitStop();}

static inline uint32_t FireEtwWaitHandleWaitStop(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventWaitHandleWaitStop(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_WINDOWS_DOTNETRUNTIME_PROVIDER_EVENTPIPE_Context = { W("Microsoft-Windows-DotNETRuntime"), 0, false, 0 };
static inline bool EventEnabledMethodDCEnd_V1(void) {return EventPipeEventEnabledMethodDCEnd_V1();}

static inline uint32_t FireEtwMethodDCEnd_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEnd_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndVerbose_V1(void) {return EventPipeEventEnabledMethodDCEndVerbose_V1();}

static inline uint32_t FireEtwMethodDCEndVerbose_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint64_t  MethodStartAddress,
    const uint32_t  MethodSize,
    const uint32_t  MethodToken,
    const uint32_t  MethodFlags,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndVerbose_V1(MethodID,ModuleID,MethodStartAddress,MethodSize,MethodToken,MethodFlags,MethodNamespace,MethodName,MethodSignature,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCEndComplete_V1(void) {return EventPipeEventEnabledDCEndComplete_V1();}

static inline uint32_t FireEtwDCEndComplete_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCEndComplete_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDCEndInit_V1(void) {return EventPipeEventEnabledDCEndInit_V1();}

static inline uint32_t FireEtwDCEndInit_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDCEndInit_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMethodDCEndILToNativeMap(void) {return EventPipeEventEnabledMethodDCEndILToNativeMap();}

static inline uint32_t FireEtwMethodDCEndILToNativeMap(
    const uint64_t  MethodID,
    const uint64_t  ReJITID,
    const uint8_t  MethodExtent,
    const uint16_t  CountOfMapEntries,
    const uint32_t* ILOffsets,
    const uint32_t* NativeOffsets,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMethodDCEndILToNativeMap(MethodID,ReJITID,MethodExtent,CountOfMapEntries,ILOffsets,NativeOffsets,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledDomainModuleDCEnd_V1(void) {return EventPipeEventEnabledDomainModuleDCEnd_V1();}

static inline uint32_t FireEtwDomainModuleDCEnd_V1(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventDomainModuleDCEnd_V1(ModuleID,AssemblyID,AppDomainID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledModuleDCEnd_V2(void) {return EventPipeEventEnabledModuleDCEnd_V2();}

static inline uint32_t FireEtwModuleDCEnd_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const uint32_t  ModuleFlags,
    const uint32_t  Reserved1,
    const ep_char8_t*  ModuleILPath,
    const ep_char8_t*  ModuleNativePath,
    const uint16_t  ClrInstanceID,
    const uint8_t* ManagedPdbSignature,
    const uint32_t  ManagedPdbAge,
    const ep_char8_t*  ManagedPdbBuildPath,
    const uint8_t* NativePdbSignature,
    const uint32_t  NativePdbAge,
    const ep_char8_t*  NativePdbBuildPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventModuleDCEnd_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAssemblyDCEnd_V1(void) {return EventPipeEventEnabledAssemblyDCEnd_V1();}

static inline uint32_t FireEtwAssemblyDCEnd_V1(
    const uint64_t  AssemblyID,
    const uint64_t  AppDomainID,
    const uint64_t  BindingID,
    const uint32_t  AssemblyFlags,
    const ep_char8_t*  FullyQualifiedAssemblyName,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAssemblyDCEnd_V1(AssemblyID,AppDomainID,BindingID,AssemblyFlags,FullyQualifiedAssemblyName,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledAppDomainDCEnd_V1(void) {return EventPipeEventEnabledAppDomainDCEnd_V1();}

static inline uint32_t FireEtwAppDomainDCEnd_V1(
    const uint64_t  AppDomainID,
    const uint32_t  AppDomainFlags,
    const ep_char8_t*  AppDomainName,
    const uint32_t  AppDomainIndex,
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventAppDomainDCEnd_V1(AppDomainID,AppDomainFlags,AppDomainName,AppDomainIndex,ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledRuntimeInformationDCStart(void) {return EventPipeEventEnabledRuntimeInformationDCStart();}

static inline uint32_t FireEtwRuntimeInformationDCStart(
    const uint16_t  ClrInstanceID,
    const uint16_t  Sku,
    const uint16_t  BclMajorVersion,
    const uint16_t  BclMinorVersion,
    const uint16_t  BclBuildNumber,
    const uint16_t  BclQfeNumber,
    const uint16_t  VMMajorVersion,
    const uint16_t  VMMinorVersion,
    const uint16_t  VMBuildNumber,
    const uint16_t  VMQfeNumber,
    const uint32_t  StartupFlags,
    const uint8_t  StartupMode,
    const ep_char8_t*  CommandLine,
    const uint8_t* ComObjectGuid,
    const ep_char8_t*  RuntimeDllPath,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventRuntimeInformationDCStart(ClrInstanceID,Sku,BclMajorVersion,BclMinorVersion,BclBuildNumber,BclQfeNumber,VMMajorVersion,VMMinorVersion,VMBuildNumber,VMQfeNumber,StartupFlags,StartupMode,CommandLine,ComObjectGuid,RuntimeDllPath,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledExecutionCheckpointDCEnd(void) {return EventPipeEventEnabledExecutionCheckpointDCEnd();}

static inline uint32_t FireEtwExecutionCheckpointDCEnd(
    const uint16_t  ClrInstanceID,
    const ep_char8_t*  Name,
    const int64_t  Timestamp,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventExecutionCheckpointDCEnd(ClrInstanceID,Name,Timestamp,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_WINDOWS_DOTNETRUNTIME_RUNDOWN_PROVIDER_EVENTPIPE_Context = { W("Microsoft-Windows-DotNETRuntimeRundown"), 0, false, 0 };
__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_WINDOWS_DOTNETRUNTIME_STRESS_PROVIDER_EVENTPIPE_Context = { W("Microsoft-Windows-DotNETRuntimeStress"), 0, false, 0 };
static inline bool EventEnabledEEStartupStart_V1(void) {return EventPipeEventEnabledEEStartupStart_V1();}

static inline uint32_t FireEtwEEStartupStart_V1(
    const uint16_t  ClrInstanceID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventEEStartupStart_V1(ClrInstanceID,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_WINDOWS_DOTNETRUNTIME_PRIVATE_PROVIDER_EVENTPIPE_Context = { W("Microsoft-Windows-DotNETRuntimePrivate"), 0, false, 0 };
static inline bool EventEnabledMonoProfilerContextLoaded(void) {return EventPipeEventEnabledMonoProfilerContextLoaded();}

static inline uint32_t FireEtwMonoProfilerContextLoaded(
    const void*  ObjectID,
    const uint64_t  AppDomainID,
    const uint64_t  ContextID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerContextLoaded(ObjectID,AppDomainID,ContextID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerContextUnloaded(void) {return EventPipeEventEnabledMonoProfilerContextUnloaded();}

static inline uint32_t FireEtwMonoProfilerContextUnloaded(
    const void*  ObjectID,
    const uint64_t  AppDomainID,
    const uint64_t  ContextID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerContextUnloaded(ObjectID,AppDomainID,ContextID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainLoading(void) {return EventPipeEventEnabledMonoProfilerAppDomainLoading();}

static inline uint32_t FireEtwMonoProfilerAppDomainLoading(
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainLoading(AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainLoaded(void) {return EventPipeEventEnabledMonoProfilerAppDomainLoaded();}

static inline uint32_t FireEtwMonoProfilerAppDomainLoaded(
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainLoaded(AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainUnloading(void) {return EventPipeEventEnabledMonoProfilerAppDomainUnloading();}

static inline uint32_t FireEtwMonoProfilerAppDomainUnloading(
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainUnloading(AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainUnloaded(void) {return EventPipeEventEnabledMonoProfilerAppDomainUnloaded();}

static inline uint32_t FireEtwMonoProfilerAppDomainUnloaded(
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainUnloaded(AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAppDomainName(void) {return EventPipeEventEnabledMonoProfilerAppDomainName();}

static inline uint32_t FireEtwMonoProfilerAppDomainName(
    const uint64_t  AppDomainID,
    const ep_char8_t*  AppDomainName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAppDomainName(AppDomainID,AppDomainName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitBegin(void) {return EventPipeEventEnabledMonoProfilerJitBegin();}

static inline uint32_t FireEtwMonoProfilerJitBegin(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitBegin(MethodID,ModuleID,MethodToken,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitFailed(void) {return EventPipeEventEnabledMonoProfilerJitFailed();}

static inline uint32_t FireEtwMonoProfilerJitFailed(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitFailed(MethodID,ModuleID,MethodToken,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitDone(void) {return EventPipeEventEnabledMonoProfilerJitDone();}

static inline uint32_t FireEtwMonoProfilerJitDone(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitDone(MethodID,ModuleID,MethodToken,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitDone_V1(void) {return EventPipeEventEnabledMonoProfilerJitDone_V1();}

static inline uint32_t FireEtwMonoProfilerJitDone_V1(
    const uint64_t  MethodID,
    const uint64_t  ModuleID,
    const uint32_t  MethodToken,
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitDone_V1(MethodID,ModuleID,MethodToken,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitChunkCreated(void) {return EventPipeEventEnabledMonoProfilerJitChunkCreated();}

static inline uint32_t FireEtwMonoProfilerJitChunkCreated(
    const void*  ChunkID,
    const uint64_t  ChunkSize,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitChunkCreated(ChunkID,ChunkSize,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitChunkDestroyed(void) {return EventPipeEventEnabledMonoProfilerJitChunkDestroyed();}

static inline uint32_t FireEtwMonoProfilerJitChunkDestroyed(
    const void*  ChunkID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitChunkDestroyed(ChunkID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitCodeBuffer(void) {return EventPipeEventEnabledMonoProfilerJitCodeBuffer();}

static inline uint32_t FireEtwMonoProfilerJitCodeBuffer(
    const void*  BufferID,
    const uint64_t  BufferSize,
    const uint8_t  BufferType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitCodeBuffer(BufferID,BufferSize,BufferType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerClassLoading(void) {return EventPipeEventEnabledMonoProfilerClassLoading();}

static inline uint32_t FireEtwMonoProfilerClassLoading(
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerClassLoading(ClassID,ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerClassFailed(void) {return EventPipeEventEnabledMonoProfilerClassFailed();}

static inline uint32_t FireEtwMonoProfilerClassFailed(
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerClassFailed(ClassID,ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerClassLoaded(void) {return EventPipeEventEnabledMonoProfilerClassLoaded();}

static inline uint32_t FireEtwMonoProfilerClassLoaded(
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const ep_char8_t*  ClassName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerClassLoaded(ClassID,ModuleID,ClassName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerClassLoaded_V1(void) {return EventPipeEventEnabledMonoProfilerClassLoaded_V1();}

static inline uint32_t FireEtwMonoProfilerClassLoaded_V1(
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const ep_char8_t*  ClassName,
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerClassLoaded_V1(ClassID,ModuleID,ClassName,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerVTableLoading(void) {return EventPipeEventEnabledMonoProfilerVTableLoading();}

static inline uint32_t FireEtwMonoProfilerVTableLoading(
    const uint64_t  VTableID,
    const uint64_t  ClassID,
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerVTableLoading(VTableID,ClassID,AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerVTableFailed(void) {return EventPipeEventEnabledMonoProfilerVTableFailed();}

static inline uint32_t FireEtwMonoProfilerVTableFailed(
    const uint64_t  VTableID,
    const uint64_t  ClassID,
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerVTableFailed(VTableID,ClassID,AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerVTableLoaded(void) {return EventPipeEventEnabledMonoProfilerVTableLoaded();}

static inline uint32_t FireEtwMonoProfilerVTableLoaded(
    const uint64_t  VTableID,
    const uint64_t  ClassID,
    const uint64_t  AppDomainID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerVTableLoaded(VTableID,ClassID,AppDomainID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleLoading(void) {return EventPipeEventEnabledMonoProfilerModuleLoading();}

static inline uint32_t FireEtwMonoProfilerModuleLoading(
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleLoading(ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleFailed(void) {return EventPipeEventEnabledMonoProfilerModuleFailed();}

static inline uint32_t FireEtwMonoProfilerModuleFailed(
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleFailed(ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleLoaded(void) {return EventPipeEventEnabledMonoProfilerModuleLoaded();}

static inline uint32_t FireEtwMonoProfilerModuleLoaded(
    const uint64_t  ModuleID,
    const ep_char8_t*  ModuleName,
    const ep_char8_t*  ModuleSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleLoaded(ModuleID,ModuleName,ModuleSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleUnloading(void) {return EventPipeEventEnabledMonoProfilerModuleUnloading();}

static inline uint32_t FireEtwMonoProfilerModuleUnloading(
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleUnloading(ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerModuleUnloaded(void) {return EventPipeEventEnabledMonoProfilerModuleUnloaded();}

static inline uint32_t FireEtwMonoProfilerModuleUnloaded(
    const uint64_t  ModuleID,
    const ep_char8_t*  ModuleName,
    const ep_char8_t*  ModuleSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerModuleUnloaded(ModuleID,ModuleName,ModuleSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAssemblyLoading(void) {return EventPipeEventEnabledMonoProfilerAssemblyLoading();}

static inline uint32_t FireEtwMonoProfilerAssemblyLoading(
    const uint64_t  AssemblyID,
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAssemblyLoading(AssemblyID,ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAssemblyLoaded(void) {return EventPipeEventEnabledMonoProfilerAssemblyLoaded();}

static inline uint32_t FireEtwMonoProfilerAssemblyLoaded(
    const uint64_t  AssemblyID,
    const uint64_t  ModuleID,
    const ep_char8_t*  AssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAssemblyLoaded(AssemblyID,ModuleID,AssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAssemblyUnloading(void) {return EventPipeEventEnabledMonoProfilerAssemblyUnloading();}

static inline uint32_t FireEtwMonoProfilerAssemblyUnloading(
    const uint64_t  AssemblyID,
    const uint64_t  ModuleID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAssemblyUnloading(AssemblyID,ModuleID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerAssemblyUnloaded(void) {return EventPipeEventEnabledMonoProfilerAssemblyUnloaded();}

static inline uint32_t FireEtwMonoProfilerAssemblyUnloaded(
    const uint64_t  AssemblyID,
    const uint64_t  ModuleID,
    const ep_char8_t*  AssemblyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerAssemblyUnloaded(AssemblyID,ModuleID,AssemblyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodEnter(void) {return EventPipeEventEnabledMonoProfilerMethodEnter();}

static inline uint32_t FireEtwMonoProfilerMethodEnter(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodEnter(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodLeave(void) {return EventPipeEventEnabledMonoProfilerMethodLeave();}

static inline uint32_t FireEtwMonoProfilerMethodLeave(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodLeave(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodTailCall(void) {return EventPipeEventEnabledMonoProfilerMethodTailCall();}

static inline uint32_t FireEtwMonoProfilerMethodTailCall(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodTailCall(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodExceptionLeave(void) {return EventPipeEventEnabledMonoProfilerMethodExceptionLeave();}

static inline uint32_t FireEtwMonoProfilerMethodExceptionLeave(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodExceptionLeave(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodFree(void) {return EventPipeEventEnabledMonoProfilerMethodFree();}

static inline uint32_t FireEtwMonoProfilerMethodFree(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodFree(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodBeginInvoke(void) {return EventPipeEventEnabledMonoProfilerMethodBeginInvoke();}

static inline uint32_t FireEtwMonoProfilerMethodBeginInvoke(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodBeginInvoke(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMethodEndInvoke(void) {return EventPipeEventEnabledMonoProfilerMethodEndInvoke();}

static inline uint32_t FireEtwMonoProfilerMethodEndInvoke(
    const uint64_t  MethodID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMethodEndInvoke(MethodID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerExceptionThrow(void) {return EventPipeEventEnabledMonoProfilerExceptionThrow();}

static inline uint32_t FireEtwMonoProfilerExceptionThrow(
    const uint64_t  TypeID,
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerExceptionThrow(TypeID,ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerExceptionClause(void) {return EventPipeEventEnabledMonoProfilerExceptionClause();}

static inline uint32_t FireEtwMonoProfilerExceptionClause(
    const uint8_t  ClauseType,
    const uint32_t  ClauseIdx,
    const uint64_t  MethodID,
    const uint64_t  TypeID,
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerExceptionClause(ClauseType,ClauseIdx,MethodID,TypeID,ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCEvent(void) {return EventPipeEventEnabledMonoProfilerGCEvent();}

static inline uint32_t FireEtwMonoProfilerGCEvent(
    const uint8_t  GCEventType,
    const uint32_t  GCGeneration,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCEvent(GCEventType,GCGeneration,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCAllocation(void) {return EventPipeEventEnabledMonoProfilerGCAllocation();}

static inline uint32_t FireEtwMonoProfilerGCAllocation(
    const uint64_t  VTableID,
    const void*  ObjectID,
    const uint64_t  ObjectSize,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCAllocation(VTableID,ObjectID,ObjectSize,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCMoves(void) {return EventPipeEventEnabledMonoProfilerGCMoves();}

static inline uint32_t FireEtwMonoProfilerGCMoves(
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCMoves(Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCResize(void) {return EventPipeEventEnabledMonoProfilerGCResize();}

static inline uint32_t FireEtwMonoProfilerGCResize(
    const uint64_t  NewSize,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCResize(NewSize,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHandleCreated(void) {return EventPipeEventEnabledMonoProfilerGCHandleCreated();}

static inline uint32_t FireEtwMonoProfilerGCHandleCreated(
    const uint64_t  HandleID,
    const uint8_t  HandleType,
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHandleCreated(HandleID,HandleType,ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHandleDeleted(void) {return EventPipeEventEnabledMonoProfilerGCHandleDeleted();}

static inline uint32_t FireEtwMonoProfilerGCHandleDeleted(
    const uint64_t  HandleID,
    const uint8_t  HandleType,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHandleDeleted(HandleID,HandleType,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCFinalizing(void) {return EventPipeEventEnabledMonoProfilerGCFinalizing();}

static inline uint32_t FireEtwMonoProfilerGCFinalizing(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCFinalizing(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCFinalized(void) {return EventPipeEventEnabledMonoProfilerGCFinalized();}

static inline uint32_t FireEtwMonoProfilerGCFinalized(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCFinalized(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCFinalizingObject(void) {return EventPipeEventEnabledMonoProfilerGCFinalizingObject();}

static inline uint32_t FireEtwMonoProfilerGCFinalizingObject(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCFinalizingObject(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCFinalizedObject(void) {return EventPipeEventEnabledMonoProfilerGCFinalizedObject();}

static inline uint32_t FireEtwMonoProfilerGCFinalizedObject(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCFinalizedObject(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCRootRegister(void) {return EventPipeEventEnabledMonoProfilerGCRootRegister();}

static inline uint32_t FireEtwMonoProfilerGCRootRegister(
    const void*  RootID,
    const uint64_t  RootSize,
    const uint8_t  RootType,
    const uint64_t  RootKeyID,
    const ep_char8_t*  RootKeyName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCRootRegister(RootID,RootSize,RootType,RootKeyID,RootKeyName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCRootUnregister(void) {return EventPipeEventEnabledMonoProfilerGCRootUnregister();}

static inline uint32_t FireEtwMonoProfilerGCRootUnregister(
    const void*  RootID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCRootUnregister(RootID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCRoots(void) {return EventPipeEventEnabledMonoProfilerGCRoots();}

static inline uint32_t FireEtwMonoProfilerGCRoots(
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCRoots(Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHeapDumpStart(void) {return EventPipeEventEnabledMonoProfilerGCHeapDumpStart();}

static inline uint32_t FireEtwMonoProfilerGCHeapDumpStart(
    const ep_char8_t*  HeapCollectParam,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHeapDumpStart(HeapCollectParam,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHeapDumpStop(void) {return EventPipeEventEnabledMonoProfilerGCHeapDumpStop();}

static inline uint32_t FireEtwMonoProfilerGCHeapDumpStop(
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHeapDumpStop(ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHeapDumpObjectReference(void) {return EventPipeEventEnabledMonoProfilerGCHeapDumpObjectReference();}

static inline uint32_t FireEtwMonoProfilerGCHeapDumpObjectReference(
    const void*  ObjectID,
    const uint64_t  VTableID,
    const uint64_t  ObjectSize,
    const uint8_t  ObjectGeneration,
    const uint32_t  Count,
    int Values_ElementSize,
    const void* Values,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHeapDumpObjectReference(ObjectID,VTableID,ObjectSize,ObjectGeneration,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMonitorContention(void) {return EventPipeEventEnabledMonoProfilerMonitorContention();}

static inline uint32_t FireEtwMonoProfilerMonitorContention(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMonitorContention(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMonitorFailed(void) {return EventPipeEventEnabledMonoProfilerMonitorFailed();}

static inline uint32_t FireEtwMonoProfilerMonitorFailed(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMonitorFailed(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerMonitorAcquired(void) {return EventPipeEventEnabledMonoProfilerMonitorAcquired();}

static inline uint32_t FireEtwMonoProfilerMonitorAcquired(
    const void*  ObjectID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerMonitorAcquired(ObjectID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadStarted(void) {return EventPipeEventEnabledMonoProfilerThreadStarted();}

static inline uint32_t FireEtwMonoProfilerThreadStarted(
    const uint64_t  ThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadStarted(ThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadStopping(void) {return EventPipeEventEnabledMonoProfilerThreadStopping();}

static inline uint32_t FireEtwMonoProfilerThreadStopping(
    const uint64_t  ThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadStopping(ThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadStopped(void) {return EventPipeEventEnabledMonoProfilerThreadStopped();}

static inline uint32_t FireEtwMonoProfilerThreadStopped(
    const uint64_t  ThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadStopped(ThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadExited(void) {return EventPipeEventEnabledMonoProfilerThreadExited();}

static inline uint32_t FireEtwMonoProfilerThreadExited(
    const uint64_t  ThreadID,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadExited(ThreadID,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerThreadName(void) {return EventPipeEventEnabledMonoProfilerThreadName();}

static inline uint32_t FireEtwMonoProfilerThreadName(
    const uint64_t  ThreadID,
    const ep_char8_t*  ThreadName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerThreadName(ThreadID,ThreadName,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerJitDoneVerbose(void) {return EventPipeEventEnabledMonoProfilerJitDoneVerbose();}

static inline uint32_t FireEtwMonoProfilerJitDoneVerbose(
    const uint64_t  MethodID,
    const ep_char8_t*  MethodNamespace,
    const ep_char8_t*  MethodName,
    const ep_char8_t*  MethodSignature,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerJitDoneVerbose(MethodID,MethodNamespace,MethodName,MethodSignature,ActivityId,RelatedActivityId);
    return status;
}

static inline bool EventEnabledMonoProfilerGCHeapDumpVTableClassReference(void) {return EventPipeEventEnabledMonoProfilerGCHeapDumpVTableClassReference();}

static inline uint32_t FireEtwMonoProfilerGCHeapDumpVTableClassReference(
    const uint64_t  VTableID,
    const uint64_t  ClassID,
    const uint64_t  ModuleID,
    const ep_char8_t*  ClassName,
    const uint8_t* ActivityId,
    const uint8_t* RelatedActivityId
)
{
    uint32_t status = EventPipeWriteEventMonoProfilerGCHeapDumpVTableClassReference(VTableID,ClassID,ModuleID,ClassName,ActivityId,RelatedActivityId);
    return status;
}

__attribute__((weak)) EVENTPIPE_TRACE_CONTEXT MICROSOFT_DOTNETRUNTIME_MONO_PROFILER_PROVIDER_EVENTPIPE_Context = { W("Microsoft-DotNETRuntimeMonoProfiler"), 0, false, 0 };
